-- Plugin script Crmaillre
--
--################################################################################ 
--					_     _     _     _     _     _     _
--		      	   / \   / \   / \   / \   / \   / \   / \
--			      /   \_/   \_/   \_/   \_/   \_/   \_/   \
--                |_______________________________________| 
--
--################################################################################ 
--
-- AUTEUR : 
-- Par Athanaze
-- Le 17/06/2004
-- Dernire modification : 10/09/2004
-- Version 1.1
-- Web http://www.athanaze.fr.St
-- Contact : athanaze@fr.st
-- 
-- Ddi  la communaut 3DStation http://www.3d-station.com
-- 
-- Merci pour leur aide : Ixion2027, Mr Boumba, la communaut 3d-station
--
--################################################################################
--
-- DESCRIPTION : permet de crer des primitives crmaillres paramtriques
--		Paramtres :
--			Module : dtermine la taille des dents
--			Largeur : largeur de la crmaillre
--			Nombre : nombre de dent de la crmaillre

-- 			Height
--		
--################################################################################
--		
-- CONTENU DE L'ARCHIVE :
-- - lisez-moi.txt 
-- - cremaillere.ms ( ce fichier)
-- 
-- INSTALLATION :
-- Copier le fichier cremaillere.ms dans le dossier "X:\3DS max\stdsplugs\stdscripts\"
-- Si vous dsirez sauvegarder les primitives avec votre scne, vous devrez
-- sauvegarder ce script dans le .
-- Si vous ne le faites pas, l'ouverture d'un fichier contenant une primitive crmaillre
-- fera apparatre un message d'erreur.
--
-- L'objet Crmaillre apparat dans la catgorie "Athanaze primitive" 
-- Elle est accessible  partir du panneau Cration >> Gomtrie >> liste droutante catgorie
--
-- FICHIERS REQUIS : aucun
--
--################################################################################
--
-- INFORMATIONS :
-- Pour crer une crmaillre :
-- _ cliquer sur le bouton crmaillre
-- _ cliquer et glisser pour dterminer le module et la largeur de la crmaillre
-- _ fates un clic droit pour mettre fin au processus de cration
--
-- Vous pouvez par la suite modifier les paramtres de la crmaillres via le panneau Modifier.
--
--################################################################################
-- 
-- RESPONSABILITEES :
-- L'utilisation de ce script se fait a vos risques et prils.
-- En particulier, l'auteur de ce script ne serait en aucun cas tre tenu pour 
-- responsable d'une perte ou dtrioration totale ou partielle de donnes ou matriel. 
-- La vente ou l'exploitation pcuniaire est strictement interdite
--
-- Vous pouvez en revanche librement modifier tout ou partie de ce code  votre gr.
-- Je vous remercierais dans ce cas de bien vouloir m'en faire parvenir une copie.
--
--################################################################################
-- 
-- BUGS :
-- Si rencontrez des problmes lors de l'utilisation de ce script, veuillez m'en
-- informer que je tche d'y remdier. je vous demanderais d'tre le plus prcis
-- possible dans la description du problme rencontr (conditions d'utilisations,
-- version du script, version de 3DSMax, messages d'erreurs, etc...)
--
--################################################################################
-- 
-- CODE

plugin simpleobject Crmaillre
name:"Crmaillre" 
classID: #(0x9547a475, 0xf5097f76)
category:"Athanaze Primitives" 
( 
	parameters main rollout:params 
	( 
	module type:#float ui:module default:0 
	width type:#float ui:width default:0 
	Number type:#integer ui:Number default:15 
	
	Height type:#float ui:Height default:0
	left type:#float ui:left default:10
	right type:#float ui:right default:10
	) 
	
	rollout params "Paramtres" 
	( 
		-- groupe marche
		group "Dents"
		( 
		spinner module "Module :" range:[0,1000,0] align:#right width: 90 height:16 
		spinner width "Largeur :" range:[-1000,1000,0] align:#right width: 90 height:16
		spinner Number "Nombre :" type:#integer range:[2,100,15] align:#right width: 60 height:16
		)
		
		group "Semelle"
		(
		spinner Height " Hauteur :" type:#float range:[0,1000,0] align:#right width: 90 height:16
		spinner left "Longeur 1 :" type:#float range:[0,1000,10] align:#right width: 90 height:16
		spinner right "Longeur 2 :" type:#float range:[0,1000,10] align:#right width: 90 height:16
		)
 
	) 
	
	rollout AboutRollout "A propos" 
	( 
	label About_1 "Crmaillre - par Athanaze " 
	label About_2 "v 1.1 - 10/09/2004" 
	label About_3 "*****" 
	hyperlink About_4 "Site web" address:"http://www.athanaze.fr.st" align:#center color:(color 0 0 255) 
	hyperlink About_5 "Contact" address:"mailto:athanaze@fr.st?subject=Crmaillre" align:#center color:(color 0 0 255) 
	label About_6 "*****" 	
	label About_7 "Ddi  la" 
	hyperlink About_8 "Communaut 3DStation" address:"http://www.3d-station.com" align:#center color:(color 0 0 255) 
	) 
	
	on buildMesh do 
	( 
		local v =#() 
		local f =#()
		local ed = #()
		local nb = 0 
		local Flist = #()
		local EdgeSelSet=#() 
		
		append v [0,0,0] -- premier vertex
		
		-- definition des vertices du profil d'une dent
		for i = 0 to Number-1 do
		(
			append v [ module*i*PI ,0,.75*module + Height]
			append v [ module*(i*PI + .125) ,0,.8*module + Height]
			append v [ module*(i*PI + .25) ,0,module + Height] 
			append v [ module*(i*PI + 2*sin 20 + .25),0,3*module + Height] 
			append v [ module*(i*PI + PI/2 + .25) ,0,3*module + Height] 
			append v [ module* (i*PI + 2*sin 20 + PI/2 + .25) ,0,module + Height]
			append v [ module*(i*PI + 2*sin 20 + PI/2 + .375) ,0,.8*module + Height]
			append v [ module*(i*PI + 2*sin 20 + PI/2 + .5) ,0,.75*module + Height] 
			append v [ module*(i*PI + (PI/2-PI/8)+ .25) ,0, 0]
		)
		append v [ v[v.count-1].x,0,0]-- dernier vertex du profil
				
		-- definition des faces des dents
		for i = 1 to (Number*9) by 9 do 
		( 
			for j = 0 to 7 do 
			(
				append f [i+9,i+j+1,i+j]
			)			
			append f [i+9,i+10,i+8]
		)

		-- creation du mesh 
		setmesh mesh verts:v faces:f 
		
		-- rcupre les faces pour le premier 'bout' LEFT
		local face_left = #(1+(getNumFaces mesh),2+(getNumFaces mesh))
		
		-- extrusion
		extrudeface mesh #all -width 100 dir:#independent
		
		-- rcupre les faces pour le deuxime 'bout' RIGHT
		local face_right = #((getNumFaces mesh)-1,(getNumFaces mesh))

		
		-- re-cration des faces extrud
		for i = 1 to (Number*9)-1 by 9 do 
		( 
			undo OFF
			(
				for j = 0 to 7 do 
				(
					meshop.createPolygon mesh #(i+9,i+j,i+j+1)
				)	
				meshop.createPolygon mesh #(i+9,i+8,i+10)
			)
		)

		-- auto edge		 
		meshop.autoEdge mesh #all 45 type:#SetClear 
		
		-- cration bout de semelle
		undo OFF
		(
			if (width > 0) then 
			(
				if left > 0 then 
					extrudeface mesh face_left -left 100 dir:#independent
				if right > 0 then 
					extrudeface mesh face_right -right 100 dir:#independent
			)
			else
			(
				if left > 0 then 
					extrudeface mesh face_left left 100 dir:#independent
				if right > 0 then 
				extrudeface mesh face_right right 100 dir:#independent
			)
		)
		
		-- Auto smooth
		meshop.autoSmooth mesh #all 45
		
		-- correction normales
		if (width >0) then 
		(
			meshop.flipNormals mesh #all
		)
		
		-- update 
		update mesh
	
	) -- end on buildmesh 
	
	tool create 
	( 
		on mousePoint click do 
		( 
			case click of 
			( 
				1: nodeTM.translation = gridPoint 
			) 
		) 
	
		on mouseMove click do 
		( 
			case click of 
			( 
			2: (
				module = abs(gridDist.x / PI /Number)
				width = gridDist.y
				)
			3: Height = abs(gridDist.y)
			4: #stop 
			) 
		) 
	) 
) -- end plug 




